require '_h2ph_pre.ph';

unless(defined(&_ASM_IRQ_H)) {
    eval 'sub _ASM_IRQ_H () {1;}' unless defined(&_ASM_IRQ_H);
    require 'linux/linkage.ph';
    require 'asm/segment.ph';
    eval 'sub NR_IRQS () {16;}' unless defined(&NR_IRQS);
    eval 'sub TIMER_IRQ () {0;}' unless defined(&TIMER_IRQ);
    eval 'sub __STR {
        local($x) = @_;
	    eval q($x);
    }' unless defined(&__STR);
    eval 'sub STR {
        local($x) = @_;
	    eval q( &__STR($x));
    }' unless defined(&STR);
    eval 'sub SAVE_ALL () {"cld\\n\\t" "push %gs\\n\\t" "push %fs\\n\\t" "push %es\\n\\t" "push %ds\\n\\t" "pushl %eax\\n\\t" "pushl %ebp\\n\\t" "pushl %edi\\n\\t" "pushl %esi\\n\\t" "pushl %edx\\n\\t" "pushl %ecx\\n\\t" "pushl %ebx\\n\\t" "movl $"  &STR( &KERNEL_DS) ",%edx\\n\\t" "mov %dx,%ds\\n\\t" "mov %dx,%es\\n\\t" "movl $"  &STR( &USER_DS) ",%edx\\n\\t" "mov %dx,%fs\\n\\t" "movl $0,%edx\\n\\t" "movl %edx,%db7\\n\\t";}' unless defined(&SAVE_ALL);
    eval 'sub SAVE_MOST () {"cld\\n\\t" "push %es\\n\\t" "push %ds\\n\\t" "pushl %eax\\n\\t" "pushl %edx\\n\\t" "pushl %ecx\\n\\t" "movl $"  &STR( &KERNEL_DS) ",%edx\\n\\t" "mov %dx,%ds\\n\\t" "mov %dx,%es\\n\\t";}' unless defined(&SAVE_MOST);
    eval 'sub RESTORE_MOST () {"popl %ecx\\n\\t" "popl %edx\\n\\t" "popl %eax\\n\\t" "pop %ds\\n\\t" "pop %es\\n\\t" "iret";}' unless defined(&RESTORE_MOST);
    eval 'sub ACK_FIRST {
        local($mask,$nr) = @_;
	    eval q(\\"inb $0x21,%al\\\\n\\\\t\\" \\"jmp 1f\\\\n\\" \\"1:\\\\tjmp 1f\\\\n\\" \\"1:\\\\torb $\\" $mask \\",\\" &SYMBOL_NAME_STR( &cache_21)\\"\\\\n\\\\t\\" \\"movb \\" &SYMBOL_NAME_STR( &cache_21)\\",%al\\\\n\\\\t\\" \\"outb %al,$0x21\\\\n\\\\t\\" \\"jmp 1f\\\\n\\" \\"1:\\\\tjmp 1f\\\\n\\" \\"1:\\\\tmovb $0x20,%al\\\\n\\\\t\\" \\"outb %al,$0x20\\\\n\\\\t\\");
    }' unless defined(&ACK_FIRST);
    eval 'sub ACK_SECOND {
        local($mask,$nr) = @_;
	    eval q(\\"inb $0xA1,%al\\\\n\\\\t\\" \\"jmp 1f\\\\n\\" \\"1:\\\\tjmp 1f\\\\n\\" \\"1:\\\\torb $\\" $mask \\",\\" &SYMBOL_NAME_STR( &cache_A1)\\"\\\\n\\\\t\\" \\"movb \\" &SYMBOL_NAME_STR( &cache_A1)\\",%al\\\\n\\\\t\\" \\"outb %al,$0xA1\\\\n\\\\t\\" \\"jmp 1f\\\\n\\" \\"1:\\\\tjmp 1f\\\\n\\" \\"1:\\\\tmovb $0x20,%al\\\\n\\\\t\\" \\"outb %al,$0xA0\\\\n\\\\t\\" \\"jmp 1f\\\\n\\" \\"1:\\\\tjmp 1f\\\\n\\" \\"1:\\\\toutb %al,$0x20\\\\n\\\\t\\");
    }' unless defined(&ACK_SECOND);
    eval 'sub MSGACK_SECOND {
        local($mask,$nr) = @_;
	    eval q(\\"inb $0xA1,%al\\\\n\\\\t\\" \\"jmp 1f\\\\n\\" \\"1:\\\\tjmp 1f\\\\n\\" \\"1:\\\\tmovb $0x20,%al\\\\n\\\\t\\" \\"outb %al,$0xA0\\\\n\\\\t\\" \\"jmp 1f\\\\n\\" \\"1:\\\\tjmp 1f\\\\n\\" \\"1:\\\\toutb %al,$0x20\\\\n\\\\t\\");
    }' unless defined(&MSGACK_SECOND);
    eval 'sub UNBLK_FIRST {
        local($mask) = @_;
	    eval q(\\"inb $0x21,%al\\\\n\\\\t\\" \\"jmp 1f\\\\n\\" \\"1:\\\\tjmp 1f\\\\n\\" \\"1:\\\\tandb $~(\\" $mask \\"),\\" &SYMBOL_NAME_STR( &cache_21)\\"\\\\n\\\\t\\" \\"movb \\" &SYMBOL_NAME_STR( &cache_21)\\",%al\\\\n\\\\t\\" \\"outb %al,$0x21\\\\n\\\\t\\");
    }' unless defined(&UNBLK_FIRST);
    eval 'sub UNBLK_SECOND {
        local($mask) = @_;
	    eval q(\\"inb $0xA1,%al\\\\n\\\\t\\" \\"jmp 1f\\\\n\\" \\"1:\\\\tjmp 1f\\\\n\\" \\"1:\\\\tandb $~(\\" $mask \\"),\\" &SYMBOL_NAME_STR( &cache_A1)\\"\\\\n\\\\t\\" \\"movb \\" &SYMBOL_NAME_STR( &cache_A1)\\",%al\\\\n\\\\t\\" \\"outb %al,$0xA1\\\\n\\\\t\\");
    }' unless defined(&UNBLK_SECOND);
    eval 'sub IRQ_NAME2 {
        local($nr) = @_;
	    eval q($nr &_interrupt( &void));
    }' unless defined(&IRQ_NAME2);
    eval 'sub IRQ_NAME {
        local($nr) = @_;
	    eval q( &IRQ_NAME2( &IRQ$nr));
    }' unless defined(&IRQ_NAME);
    eval 'sub FAST_IRQ_NAME {
        local($nr) = @_;
	    eval q( &IRQ_NAME2( &fast_IRQ$nr));
    }' unless defined(&FAST_IRQ_NAME);
    eval 'sub BAD_IRQ_NAME {
        local($nr) = @_;
	    eval q( &IRQ_NAME2( &bad_IRQ$nr));
    }' unless defined(&BAD_IRQ_NAME);
    if(defined(&__SMP__)) {
	unless(defined(&__SMP_PROF__)) {
	    eval 'sub SMP_PROF_INT_SPINS () {1;}' unless defined(&SMP_PROF_INT_SPINS);
	    eval 'sub SMP_PROF_IPI_CNT () {1;}' unless defined(&SMP_PROF_IPI_CNT);
	} else {
	    eval 'sub SMP_PROF_INT_SPINS () {"incl " &SYMBOL_NAME_STR( &smp_spins)"(,%eax,4)\\n\\t";}' unless defined(&SMP_PROF_INT_SPINS);
	    eval 'sub SMP_PROF_IPI_CNT () {"incl " &SYMBOL_NAME_STR( &ipi_count)"\\n\\t";}' unless defined(&SMP_PROF_IPI_CNT);
	}
	eval 'sub GET_PROCESSOR_ID () {"movl " &SYMBOL_NAME_STR( &apic_reg)", %edx\\n\\t" "movl 32(%edx), %eax\\n\\t" "shrl $24,%eax\\n\\t" "andl $0x0F,%eax\\n";}' unless defined(&GET_PROCESSOR_ID);
	eval 'sub ENTER_KERNEL () {"pushl %eax\\n\\t" "pushl %ebx\\n\\t" "pushl %ecx\\n\\t" "pushl %edx\\n\\t" "pushfl\\n\\t" "cli\\n\\t" "movl $6000, %ebx\\n\\t" "movl " &SYMBOL_NAME_STR( &smp_loops_per_tick)", %ecx\\n\\t"  &GET_PROCESSOR_ID "btsl $"  &STR( &SMP_FROM_INT) "," &SYMBOL_NAME_STR( &smp_proc_in_lock)"(,%eax,4)\\n\\t" "1: " "lock\\n\\t" "btsl $0, " &SYMBOL_NAME_STR( &kernel_flag)"\\n\\t" "jnc 3f\\n\\t" "cmpb " &SYMBOL_NAME_STR( &active_kernel_processor)", %al\\n\\t" "je 4f\\n\\t" "cmpb " &SYMBOL_NAME_STR( &boot_cpu_id)", %al\\n\\t" "jne 2f\\n\\t" "movb $1, " &SYMBOL_NAME_STR( &smp_blocked_interrupt_pending)"\\n\\t" "2: "  &SMP_PROF_INT_SPINS "btl %eax, " &SYMBOL_NAME_STR( &smp_invalidate_needed)"\\n\\t" "jnc 5f\\n\\t" "lock\\n\\t" "btrl %eax, " &SYMBOL_NAME_STR( &smp_invalidate_needed)"\\n\\t" "jnc 5f\\n\\t" "movl %cr3,%edx\\n\\t" "movl %edx,%cr3\\n" "5: btl $0, " &SYMBOL_NAME_STR( &kernel_flag)"\\n\\t" "jnc 1b\\n\\t" "cmpb " &SYMBOL_NAME_STR( &active_kernel_processor)", %al\\n\\t" "je 4f\\n\\t" "decl %ecx\\n\\t" "jne 2b\\n\\t" "decl %ebx\\n\\t" "jne 6f\\n\\t" "call " &SYMBOL_NAME_STR( &irq_deadlock_detected)"\\n\\t" "6: movl " &SYMBOL_NAME_STR( &smp_loops_per_tick)", %ecx\\n\\t" "cmpb " &SYMBOL_NAME_STR( &boot_cpu_id)", %al\\n\\t" "jne 2b\\n\\t" "incl " &SYMBOL_NAME_STR( &jiffies)"\\n\\t" "jmp 2b\\n\\t" "3: " "movb %al, " &SYMBOL_NAME_STR( &active_kernel_processor)"\\n\\t" "4: " "incl " &SYMBOL_NAME_STR( &kernel_counter)"\\n\\t" "cmpb " &SYMBOL_NAME_STR( &boot_cpu_id)", %al\\n\\t" "jne 7f\\n\\t" "movb $0, " &SYMBOL_NAME_STR( &smp_blocked_interrupt_pending)"\\n\\t" "7: " "popfl\\n\\t" "popl %edx\\n\\t" "popl %ecx\\n\\t" "popl %ebx\\n\\t" "popl %eax\\n\\t";}' unless defined(&ENTER_KERNEL);
	eval 'sub LEAVE_KERNEL () { &GET_PROCESSOR_ID "btrl $"  &STR( &SMP_FROM_INT) "," &SYMBOL_NAME_STR( &smp_proc_in_lock)"(,%eax,4)\\n\\t" "pushfl\\n\\t" "cli\\n\\t" "decl " &SYMBOL_NAME_STR( &kernel_counter)"\\n\\t" "jnz 1f\\n\\t" "movb " &SYMBOL_NAME_STR( &saved_active_kernel_processor)",%al\\n\\t" "movb %al," &SYMBOL_NAME_STR( &active_kernel_processor)"\\n\\t" "cmpb $"  &STR ( &NO_PROC_ID) ",%al\\n\\t" "jne 1f\\n\\t" "lock\\n\\t" "btrl $0, " &SYMBOL_NAME_STR( &kernel_flag)"\\n\\t" "1: " "popfl\\n\\t";}' unless defined(&LEAVE_KERNEL);
	eval 'sub BUILD_IRQ {
	    local($chip,$nr,$mask) = @_;
    	    eval q( &asmlinkage  &void  &IRQ_NAME($nr);  &asmlinkage  &void  &FAST_IRQ_NAME($nr);  &asmlinkage  &void  &BAD_IRQ_NAME($nr);  &__asm__( \\"\\\\n\\" &__ALIGN_STR\\"\\\\n\\"  &SYMBOL_NAME_STR( &IRQ) $nr \\"_interrupt:\\\\n\\\\t\\" \\"pushl $-\\"$nr\\"-2\\\\n\\\\t\\"  &SAVE_ALL  &ENTER_KERNEL  &ACK_$chip($mask,($nr&7)) \\"incl \\" &SYMBOL_NAME_STR( &intr_count)\\"\\\\n\\\\t\\" \\"sti\\\\n\\\\t\\" \\"movl %esp,%ebx\\\\n\\\\t\\" \\"pushl %ebx\\\\n\\\\t\\" \\"pushl $\\" $nr \\"\\\\n\\\\t\\" \\"call \\" &SYMBOL_NAME_STR( &do_IRQ)\\"\\\\n\\\\t\\" \\"addl $8,%esp\\\\n\\\\t\\" \\"cli\\\\n\\\\t\\"  &UNBLK_$chip($mask) \\"decl \\" &SYMBOL_NAME_STR( &intr_count)\\"\\\\n\\\\t\\" \\"incl \\" &SYMBOL_NAME_STR( &syscall_count)\\"\\\\n\\\\t\\" \\"jmp ret_from_sys_call\\\\n\\" \\"\\\\n\\" &__ALIGN_STR\\"\\\\n\\"  &SYMBOL_NAME_STR( &fast_IRQ) $nr \\"_interrupt:\\\\n\\\\t\\"  &SAVE_MOST  &ENTER_KERNEL  &ACK_$chip($mask,($nr&7)) \\"incl \\" &SYMBOL_NAME_STR( &intr_count)\\"\\\\n\\\\t\\" \\"pushl $\\" $nr \\"\\\\n\\\\t\\" \\"call \\" &SYMBOL_NAME_STR( &do_fast_IRQ)\\"\\\\n\\\\t\\" \\"addl $4,%esp\\\\n\\\\t\\" \\"cli\\\\n\\\\t\\"  &UNBLK_$chip($mask) \\"decl \\" &SYMBOL_NAME_STR( &intr_count)\\"\\\\n\\\\t\\"  &LEAVE_KERNEL  &RESTORE_MOST \\"\\\\n\\" &__ALIGN_STR\\"\\\\n\\"  &SYMBOL_NAME_STR( &bad_IRQ) $nr \\"_interrupt:\\\\n\\\\t\\"  &SAVE_MOST  &ENTER_KERNEL  &ACK_$chip($mask,($nr&7))  &LEAVE_KERNEL  &RESTORE_MOST););
	}' unless defined(&BUILD_IRQ);
	eval 'sub BUILD_TIMER_IRQ {
	    local($chip,$nr,$mask) = @_;
    	    eval q( &asmlinkage  &void  &IRQ_NAME($nr);  &asmlinkage  &void  &FAST_IRQ_NAME($nr);  &asmlinkage  &void  &BAD_IRQ_NAME($nr);  &__asm__( \\"\\\\n\\" &__ALIGN_STR\\"\\\\n\\"  &SYMBOL_NAME_STR( &fast_IRQ) $nr \\"_interrupt:\\\\n\\\\t\\"  &SYMBOL_NAME_STR( &bad_IRQ) $nr \\"_interrupt:\\\\n\\\\t\\"  &SYMBOL_NAME_STR( &IRQ) $nr \\"_interrupt:\\\\n\\\\t\\" \\"pushl $-\\"$nr\\"-2\\\\n\\\\t\\"  &SAVE_ALL  &ENTER_KERNEL  &ACK_$chip($mask,($nr&7)) \\"incl \\" &SYMBOL_NAME_STR( &intr_count)\\"\\\\n\\\\t\\" \\"movl %esp,%ebx\\\\n\\\\t\\" \\"pushl %ebx\\\\n\\\\t\\" \\"pushl $\\" $nr \\"\\\\n\\\\t\\" \\"call \\" &SYMBOL_NAME_STR( &do_IRQ)\\"\\\\n\\\\t\\" \\"addl $8,%esp\\\\n\\\\t\\" \\"cli\\\\n\\\\t\\"  &UNBLK_$chip($mask) \\"decl \\" &SYMBOL_NAME_STR( &intr_count)\\"\\\\n\\\\t\\" \\"incl \\" &SYMBOL_NAME_STR( &syscall_count)\\"\\\\n\\\\t\\" \\"jmp ret_from_sys_call\\\\n\\"););
	}' unless defined(&BUILD_TIMER_IRQ);
	eval 'sub BUILD_MSGIRQ {
	    local($chip,$nr,$mask) = @_;
    	    eval q( &asmlinkage  &void  &IRQ_NAME($nr);  &asmlinkage  &void  &FAST_IRQ_NAME($nr);  &asmlinkage  &void  &BAD_IRQ_NAME($nr);  &__asm__( \\"\\\\n\\" &__ALIGN_STR\\"\\\\n\\"  &SYMBOL_NAME_STR( &IRQ) $nr \\"_interrupt:\\\\n\\\\t\\"  &SYMBOL_NAME_STR( &fast_IRQ) $nr \\"_interrupt:\\\\n\\\\t\\"  &SAVE_MOST  &MSGACK_$chip($mask,($nr&7))  &SMP_PROF_IPI_CNT \\"pushl $\\" $nr \\"\\\\n\\\\t\\" \\"call \\" &SYMBOL_NAME_STR( &do_fast_IRQ)\\"\\\\n\\\\t\\" \\"addl $4,%esp\\\\n\\\\t\\" \\"cli\\\\n\\\\t\\"  &RESTORE_MOST \\"\\\\n\\" &__ALIGN_STR\\"\\\\n\\"  &SYMBOL_NAME_STR( &bad_IRQ) $nr \\"_interrupt:\\\\n\\\\t\\"  &SAVE_MOST  &ACK_$chip($mask,($nr&7))  &RESTORE_MOST););
	}' unless defined(&BUILD_MSGIRQ);
	eval 'sub BUILD_RESCHEDIRQ {
	    local($nr) = @_;
    	    eval q( &asmlinkage  &void  &IRQ_NAME($nr);  &__asm__( \\"\\\\n\\" &__ALIGN_STR\\"\\\\n\\"  &SYMBOL_NAME_STR( &IRQ) $nr \\"_interrupt:\\\\n\\\\t\\" \\"pushl $-\\"$nr\\"-2\\\\n\\\\t\\"  &SAVE_ALL  &ENTER_KERNEL \\"incl \\" &SYMBOL_NAME_STR( &intr_count)\\"\\\\n\\\\t\\" \\"sti\\\\n\\\\t\\" \\"movl %esp,%ebx\\\\n\\\\t\\" \\"pushl %ebx\\\\n\\\\t\\" \\"pushl $\\" $nr \\"\\\\n\\\\t\\" \\"call \\" &SYMBOL_NAME_STR( &smp_reschedule_irq)\\"\\\\n\\\\t\\" \\"addl $8,%esp\\\\n\\\\t\\" \\"cli\\\\n\\\\t\\" \\"decl \\" &SYMBOL_NAME_STR( &intr_count)\\"\\\\n\\\\t\\" \\"incl \\" &SYMBOL_NAME_STR( &syscall_count)\\"\\\\n\\\\t\\" \\"jmp ret_from_sys_call\\\\n\\"););
	}' unless defined(&BUILD_RESCHEDIRQ);
    } else {
	eval 'sub BUILD_IRQ {
	    local($chip,$nr,$mask) = @_;
    	    eval q( &asmlinkage  &void  &IRQ_NAME($nr);  &asmlinkage  &void  &FAST_IRQ_NAME($nr);  &asmlinkage  &void  &BAD_IRQ_NAME($nr);  &__asm__( \\"\\\\n\\" &__ALIGN_STR\\"\\\\n\\"  &SYMBOL_NAME_STR( &IRQ) $nr \\"_interrupt:\\\\n\\\\t\\" \\"pushl $-\\"$nr\\"-2\\\\n\\\\t\\"  &SAVE_ALL  &ACK_$chip($mask,($nr&7)) \\"incl \\" &SYMBOL_NAME_STR( &intr_count)\\"\\\\n\\\\t\\" \\"sti\\\\n\\\\t\\" \\"movl %esp,%ebx\\\\n\\\\t\\" \\"pushl %ebx\\\\n\\\\t\\" \\"pushl $\\" $nr \\"\\\\n\\\\t\\" \\"call \\" &SYMBOL_NAME_STR( &do_IRQ)\\"\\\\n\\\\t\\" \\"addl $8,%esp\\\\n\\\\t\\" \\"cli\\\\n\\\\t\\"  &UNBLK_$chip($mask) \\"decl \\" &SYMBOL_NAME_STR( &intr_count)\\"\\\\n\\\\t\\" \\"jmp ret_from_sys_call\\\\n\\" \\"\\\\n\\" &__ALIGN_STR\\"\\\\n\\"  &SYMBOL_NAME_STR( &fast_IRQ) $nr \\"_interrupt:\\\\n\\\\t\\"  &SAVE_MOST  &ACK_$chip($mask,($nr&7)) \\"incl \\" &SYMBOL_NAME_STR( &intr_count)\\"\\\\n\\\\t\\" \\"pushl $\\" $nr \\"\\\\n\\\\t\\" \\"call \\" &SYMBOL_NAME_STR( &do_fast_IRQ)\\"\\\\n\\\\t\\" \\"addl $4,%esp\\\\n\\\\t\\" \\"cli\\\\n\\\\t\\"  &UNBLK_$chip($mask) \\"decl \\" &SYMBOL_NAME_STR( &intr_count)\\"\\\\n\\\\t\\"  &RESTORE_MOST \\"\\\\n\\" &__ALIGN_STR\\"\\\\n\\"  &SYMBOL_NAME_STR( &bad_IRQ) $nr \\"_interrupt:\\\\n\\\\t\\"  &SAVE_MOST  &ACK_$chip($mask,($nr&7))  &RESTORE_MOST););
	}' unless defined(&BUILD_IRQ);
	eval 'sub BUILD_TIMER_IRQ {
	    local($chip,$nr,$mask) = @_;
    	    eval q( &asmlinkage  &void  &IRQ_NAME($nr);  &asmlinkage  &void  &FAST_IRQ_NAME($nr);  &asmlinkage  &void  &BAD_IRQ_NAME($nr);  &__asm__( \\"\\\\n\\" &__ALIGN_STR\\"\\\\n\\"  &SYMBOL_NAME_STR( &fast_IRQ) $nr \\"_interrupt:\\\\n\\\\t\\"  &SYMBOL_NAME_STR( &bad_IRQ) $nr \\"_interrupt:\\\\n\\\\t\\"  &SYMBOL_NAME_STR( &IRQ) $nr \\"_interrupt:\\\\n\\\\t\\" \\"pushl $-\\"$nr\\"-2\\\\n\\\\t\\"  &SAVE_ALL  &ACK_$chip($mask,($nr&7)) \\"incl \\" &SYMBOL_NAME_STR( &intr_count)\\"\\\\n\\\\t\\" \\"movl %esp,%ebx\\\\n\\\\t\\" \\"pushl %ebx\\\\n\\\\t\\" \\"pushl $\\" $nr \\"\\\\n\\\\t\\" \\"call \\" &SYMBOL_NAME_STR( &do_IRQ)\\"\\\\n\\\\t\\" \\"addl $8,%esp\\\\n\\\\t\\" \\"cli\\\\n\\\\t\\"  &UNBLK_$chip($mask) \\"decl \\" &SYMBOL_NAME_STR( &intr_count)\\"\\\\n\\\\t\\" \\"jmp ret_from_sys_call\\\\n\\"););
	}' unless defined(&BUILD_TIMER_IRQ);
    }
}
1;
