require '_h2ph_pre.ph';

unless(defined(&__ASM_SYSTEM_H)) {
    eval 'sub __ASM_SYSTEM_H () {1;}' unless defined(&__ASM_SYSTEM_H);
    require 'asm/segment.ph';
    eval 'sub FIRST_TSS_ENTRY () {8;}' unless defined(&FIRST_TSS_ENTRY);
    eval 'sub FIRST_LDT_ENTRY () {( &FIRST_TSS_ENTRY+1);}' unless defined(&FIRST_LDT_ENTRY);
    eval 'sub _TSS {
        local($n) = @_;
	    eval q(((( $n)<<4)+( &FIRST_TSS_ENTRY<<3)));
    }' unless defined(&_TSS);
    eval 'sub _LDT {
        local($n) = @_;
	    eval q(((( $n)<<4)+( &FIRST_LDT_ENTRY<<3)));
    }' unless defined(&_LDT);
    eval 'sub load_TR {
        local($n) = @_;
	    eval q( &__asm__(\\"ltr %%ax\\": :\\"a\\" ( &_TSS($n))));
    }' unless defined(&load_TR);
    eval 'sub load_ldt {
        local($n) = @_;
	    eval q( &__asm__(\\"lldt %%ax\\": :\\"a\\" ( &_LDT($n))));
    }' unless defined(&load_ldt);
    eval 'sub store_TR {
        local($n) = @_;
	    eval q( &__asm__(\\"str %%ax\\\\n\\\\t\\" \\"subl %2,%%eax\\\\n\\\\t\\" \\"shrl $4,%%eax\\" :\\"=a\\" ($n) :\\"0\\" (0),\\"i\\" ( &FIRST_TSS_ENTRY<<3)));
    }' unless defined(&store_TR);
    eval 'sub loaddebug {
        local($tsk,$register) = @_;
	    eval q( &__asm__(\\"movl %0,%%edx\\\\n\\\\t\\" \\"movl %%edx,%%db\\" $register \\"\\\\n\\\\t\\" : :\\"m\\" ( ($tsk->{debugreg[$register]})) :\\"dx\\"););
    }' unless defined(&loaddebug);
    if(defined(&__SMP__)) {
	eval 'sub switch_to {
	    local($prev,$next) = @_;
    	    eval q( &do {  &cli();  &if( ($prev->{flags})& &PF_USEDFPU) {  &__asm__  &__volatile__(\\"fnsave %0\\":\\"=m\\" ( ($prev->{tss}->{i387}->{hard})));  &__asm__  &__volatile__(\\"fwait\\");  ($prev->{flags})&=~ &PF_USEDFPU; }  ($prev->{lock_depth})= &syscall_count;  &kernel_counter+= ($next->{lock_depth})- ($prev->{lock_depth});  &syscall_count= ($next->{lock_depth});  &__asm__(\\"pushl %%edx\\\\n\\\\t\\" \\"movl \\" &SYMBOL_NAME_STR( &apic_reg)\\",%%edx\\\\n\\\\t\\" \\"movl 0x20(%%edx), %%edx\\\\n\\\\t\\" \\"shrl $22,%%edx\\\\n\\\\t\\" \\"and  $0x3C,%%edx\\\\n\\\\t\\" \\"movl %%ecx,\\" &SYMBOL_NAME_STR( &current_set)\\"(,%%edx)\\\\n\\\\t\\" \\"popl %%edx\\\\n\\\\t\\" \\"ljmp %0\\\\n\\\\t\\" \\"sti\\\\n\\\\t\\" : :\\"m\\" (*(( ($next->{tss}->{tr}))-4)), \\"c\\" ($next));  &if( ($prev->{debugreg[7]})){  &loaddebug($prev,0);  &loaddebug($prev,1);  &loaddebug($prev,2);  &loaddebug($prev,3);  &loaddebug($prev,6); } }  &while (0));
	}' unless defined(&switch_to);
    } else {
	eval 'sub switch_to {
	    local($prev,$next) = @_;
    	    eval q( &do {  &__asm__(\\"movl %2,\\" &SYMBOL_NAME_STR( &current_set)\\"\\\\n\\\\t\\" \\"ljmp %0\\\\n\\\\t\\" \\"cmpl %1,\\" &SYMBOL_NAME_STR( &last_task_used_math)\\"\\\\n\\\\t\\" \\"jne 1f\\\\n\\\\t\\" \\"clts\\\\n\\" \\"1:\\" : :\\"m\\" (*(( ($next->{tss}->{tr}))-4)), \\"r\\" ($prev), \\"r\\" ($next));  &if( ($prev->{debugreg[7]})){  &loaddebug($prev,0);  &loaddebug($prev,1);  &loaddebug($prev,2);  &loaddebug($prev,3);  &loaddebug($prev,6); } }  &while (0));
	}' unless defined(&switch_to);
    }
    eval 'sub _set_base {
        local($addr,$base) = @_;
	    eval q( &__asm__(\\"movw %%dx,%0\\\\n\\\\t\\" \\"rorl $16,%%edx\\\\n\\\\t\\" \\"movb %%dl,%1\\\\n\\\\t\\" \\"movb %%dh,%2\\" : :\\"m\\" (*(($addr)+2)), \\"m\\" (*(($addr)+4)), \\"m\\" (*(($addr)+7)), \\"d\\" ($base) :\\"dx\\"));
    }' unless defined(&_set_base);
    eval 'sub _set_limit {
        local($addr,$limit) = @_;
	    eval q( &__asm__(\\"movw %%dx,%0\\\\n\\\\t\\" \\"rorl $16,%%edx\\\\n\\\\t\\" \\"movb %1,%%dh\\\\n\\\\t\\" \\"andb $0xf0,%%dh\\\\n\\\\t\\" \\"orb %%dh,%%dl\\\\n\\\\t\\" \\"movb %%dl,%1\\" : :\\"m\\" (*($addr)), \\"m\\" (*(($addr)+6)), \\"d\\" ($limit) :\\"dx\\"));
    }' unless defined(&_set_limit);
    eval 'sub set_base {
        local($ldt,$base) = @_;
	    eval q( &_set_base( (($ldt)) , $base ));
    }' unless defined(&set_base);
    eval 'sub set_limit {
        local($ldt,$limit) = @_;
	    eval q( &_set_limit( (($ldt)) , ($limit-1)>>12));
    }' unless defined(&set_limit);
    eval 'sub get_base {
        local($ldt) = @_;
	    eval q( &_get_base( (($ldt)) ));
    }' unless defined(&get_base);
    eval 'sub nop () {
        eval q( &__asm__  &__volatile__ (\\"nop\\"));
    }' unless defined(&nop);
    eval 'sub clts () {
        eval q( &__asm__  &__volatile__ (\\"clts\\"));
    }' unless defined(&clts);
    eval 'sub stts () {
        eval q( &__asm__  &__volatile__ ( \\"movl %%cr0,%%eax\\\\n\\\\t\\" \\"orl $8,%%eax\\\\n\\\\t\\" \\"movl %%eax,%%cr0\\" : : :\\"ax\\"));
    }' unless defined(&stts);
    eval 'sub xchg {
        local($ptr,$x) = @_;
	    eval q((( &__typeof__(*)) &__xchg(($x),($ptr),$sizeof{($ptr)})));
    }' unless defined(&xchg);
    eval 'sub tas {
        local($ptr) = @_;
	    eval q(( &xchg(($ptr),1)));
    }' unless defined(&tas);
    eval 'sub __xg {
        local($x) = @_;
	    eval q((($x)));
    }' unless defined(&__xg);
    eval 'sub mb () {
        eval q( &__asm__  &__volatile__ (\\"\\" : : :\\"memory\\"));
    }' unless defined(&mb);
    eval 'sub sti () {
        eval q( &__asm__  &__volatile__ (\\"sti\\": : :\\"memory\\"));
    }' unless defined(&sti);
    eval 'sub cli () {
        eval q( &__asm__  &__volatile__ (\\"cli\\": : :\\"memory\\"));
    }' unless defined(&cli);
    eval 'sub save_flags {
        local($x) = @_;
	    eval q( &__asm__  &__volatile__(\\"pushfl ; popl %0\\":\\"=g\\" ($x): :\\"memory\\"));
    }' unless defined(&save_flags);
    eval 'sub restore_flags {
        local($x) = @_;
	    eval q( &__asm__  &__volatile__(\\"pushl %0 ; popfl\\": :\\"g\\" ($x):\\"memory\\"));
    }' unless defined(&restore_flags);
    eval 'sub iret () {
        eval q( &__asm__  &__volatile__ (\\"iret\\": : :\\"memory\\"));
    }' unless defined(&iret);
    eval 'sub _set_gate {
        local($gate_addr,$type,$dpl,$addr) = @_;
	    eval q( &__asm__  &__volatile__ (\\"movw %%dx,%%ax\\\\n\\\\t\\" \\"movw %2,%%dx\\\\n\\\\t\\" \\"movl %%eax,%0\\\\n\\\\t\\" \\"movl %%edx,%1\\" :\\"=m\\" (*), \\"=m\\" (*(1+ )) :\\"i\\" ( (0x8000+($dpl<<13)+($type<<8))), \\"d\\" ( ($addr)),\\"a\\" ( &KERNEL_CS << 16) :\\"ax\\",\\"dx\\"));
    }' unless defined(&_set_gate);
    eval 'sub set_intr_gate {
        local($n,$addr) = @_;
	    eval q( &_set_gate( $idt[$n],14,0,$addr));
    }' unless defined(&set_intr_gate);
    eval 'sub set_trap_gate {
        local($n,$addr) = @_;
	    eval q( &_set_gate( $idt[$n],15,0,$addr));
    }' unless defined(&set_trap_gate);
    eval 'sub set_system_gate {
        local($n,$addr) = @_;
	    eval q( &_set_gate( $idt[$n],15,3,$addr));
    }' unless defined(&set_system_gate);
    eval 'sub set_call_gate {
        local($a,$addr) = @_;
	    eval q( &_set_gate($a,12,3,$addr));
    }' unless defined(&set_call_gate);
    eval 'sub _set_seg_desc {
        local($gate_addr,$type,$dpl,$base,$limit) = @_;
	    eval q({ *(($gate_addr)+1) = (($base) & 0xff000000) | ((($base) & 0x00ff0000)>>16) | (($limit) & 0xf0000) | (($dpl)<<13) | (0x00408000) | (($type)<<8); *($gate_addr) = ((($base) & 0x0000ffff)<<16) | (($limit) & 0x0ffff); });
    }' unless defined(&_set_seg_desc);
    eval 'sub _set_tssldt_desc {
        local($n,$addr,$limit,$type) = @_;
	    eval q( &__asm__  &__volatile__ (\\"movw $\\" $limit \\",%1\\\\n\\\\t\\" \\"movw %%ax,%2\\\\n\\\\t\\" \\"rorl $16,%%eax\\\\n\\\\t\\" \\"movb %%al,%3\\\\n\\\\t\\" \\"movb $\\" $type \\",%4\\\\n\\\\t\\" \\"movb $0x00,%5\\\\n\\\\t\\" \\"movb %%ah,%6\\\\n\\\\t\\" \\"rorl $16,%%eax\\" : :\\"a\\" ($addr+ &__PAGE_OFFSET), \\"m\\" (*($n)), \\"m\\" (*($n+2)), \\"m\\" (*($n+4)), \\"m\\" (*($n+5)), \\"m\\" (*($n+6)), \\"m\\" (*($n+7)) ));
    }' unless defined(&_set_tssldt_desc);
    eval 'sub set_tss_desc {
        local($n,$addr) = @_;
	    eval q( &_set_tssldt_desc(,(($addr)),235,\\"0x89\\"));
    }' unless defined(&set_tss_desc);
    eval 'sub set_ldt_desc {
        local($n,$addr,$size) = @_;
	    eval q( &_set_tssldt_desc(,(($addr)),(($size << 3) - 1),\\"0x82\\"));
    }' unless defined(&set_ldt_desc);
    eval 'sub HAVE_DISABLE_HLT () {1;}' unless defined(&HAVE_DISABLE_HLT);
}
1;
