require '_h2ph_pre.ph';

unless(defined(&_LINUX_FS_H)) {
    eval 'sub _LINUX_FS_H () {1;}' unless defined(&_LINUX_FS_H);
    require 'linux/config.ph';
    require 'linux/linkage.ph';
    require 'linux/limits.ph';
    require 'linux/wait.ph';
    require 'linux/types.ph';
    require 'linux/vfs.ph';
    require 'linux/net.ph';
    require 'linux/kdev_t.ph';
    require 'linux/ioctl.ph';
    undef(&NR_OPEN) if defined(&NR_OPEN);
    eval 'sub NR_OPEN () {256;}' unless defined(&NR_OPEN);
    eval 'sub NR_SUPER () {64;}' unless defined(&NR_SUPER);
    eval 'sub BLOCK_SIZE () {1024;}' unless defined(&BLOCK_SIZE);
    eval 'sub BLOCK_SIZE_BITS () {10;}' unless defined(&BLOCK_SIZE_BITS);
    eval 'sub NR_INODE () {3072;}' unless defined(&NR_INODE);
    eval 'sub NR_FILE () {1024;}' unless defined(&NR_FILE);
    eval 'sub MAY_EXEC () {1;}' unless defined(&MAY_EXEC);
    eval 'sub MAY_WRITE () {2;}' unless defined(&MAY_WRITE);
    eval 'sub MAY_READ () {4;}' unless defined(&MAY_READ);
    eval 'sub FMODE_READ () {1;}' unless defined(&FMODE_READ);
    eval 'sub FMODE_WRITE () {2;}' unless defined(&FMODE_WRITE);
    eval 'sub READ () {0;}' unless defined(&READ);
    eval 'sub WRITE () {1;}' unless defined(&WRITE);
    eval 'sub READA () {2;}' unless defined(&READA);
    eval 'sub WRITEA () {3;}' unless defined(&WRITEA);
    unless(defined(&NULL)) {
	eval 'sub NULL () {( 0);}' unless defined(&NULL);
    }
    eval 'sub NIL_FILP () {(0);}' unless defined(&NIL_FILP);
    eval 'sub SEL_IN () {1;}' unless defined(&SEL_IN);
    eval 'sub SEL_OUT () {2;}' unless defined(&SEL_OUT);
    eval 'sub SEL_EX () {4;}' unless defined(&SEL_EX);
    eval 'sub MS_RDONLY () {1;}' unless defined(&MS_RDONLY);
    eval 'sub MS_NOSUID () {2;}' unless defined(&MS_NOSUID);
    eval 'sub MS_NODEV () {4;}' unless defined(&MS_NODEV);
    eval 'sub MS_NOEXEC () {8;}' unless defined(&MS_NOEXEC);
    eval 'sub MS_SYNCHRONOUS () {16;}' unless defined(&MS_SYNCHRONOUS);
    eval 'sub MS_REMOUNT () {32;}' unless defined(&MS_REMOUNT);
    eval 'sub MS_MANDLOCK () {64;}' unless defined(&MS_MANDLOCK);
    eval 'sub S_WRITE () {128;}' unless defined(&S_WRITE);
    eval 'sub S_APPEND () {256;}' unless defined(&S_APPEND);
    eval 'sub S_IMMUTABLE () {512;}' unless defined(&S_IMMUTABLE);
    eval 'sub MS_NOATIME () {1024;}' unless defined(&MS_NOATIME);
    eval 'sub S_BAD_INODE () {2048;}' unless defined(&S_BAD_INODE);
    eval 'sub S_ZERO_WR () {4096;}' unless defined(&S_ZERO_WR);
    eval 'sub MS_RMT_MASK () {( &MS_RDONLY| &MS_NOSUID| &MS_NODEV| &MS_NOEXEC| &MS_SYNCHRONOUS| &MS_MANDLOCK| &MS_NOATIME);}' unless defined(&MS_RMT_MASK);
    eval 'sub MS_MGC_VAL () {0xc0ed0000;}' unless defined(&MS_MGC_VAL);
    eval 'sub MS_MGC_MSK () {0xffff0000;}' unless defined(&MS_MGC_MSK);
    eval 'sub IS_RDONLY {
        local($inode) = @_;
	    eval q(((($inode)-> &i_sb)  && (($inode)-> ($i_sb->{s_flags}) &  &MS_RDONLY)));
    }' unless defined(&IS_RDONLY);
    eval 'sub IS_NOSUID {
        local($inode) = @_;
	    eval q((($inode)-> &i_flags &  &MS_NOSUID));
    }' unless defined(&IS_NOSUID);
    eval 'sub IS_NODEV {
        local($inode) = @_;
	    eval q((($inode)-> &i_flags &  &MS_NODEV));
    }' unless defined(&IS_NODEV);
    eval 'sub IS_NOEXEC {
        local($inode) = @_;
	    eval q((($inode)-> &i_flags &  &MS_NOEXEC));
    }' unless defined(&IS_NOEXEC);
    eval 'sub IS_SYNC {
        local($inode) = @_;
	    eval q((($inode)-> &i_flags &  &MS_SYNCHRONOUS));
    }' unless defined(&IS_SYNC);
    eval 'sub IS_MANDLOCK {
        local($inode) = @_;
	    eval q((($inode)-> &i_flags &  &MS_MANDLOCK));
    }' unless defined(&IS_MANDLOCK);
    eval 'sub IS_WRITABLE {
        local($inode) = @_;
	    eval q((($inode)-> &i_flags &  &S_WRITE));
    }' unless defined(&IS_WRITABLE);
    eval 'sub IS_APPEND {
        local($inode) = @_;
	    eval q((($inode)-> &i_flags &  &S_APPEND));
    }' unless defined(&IS_APPEND);
    eval 'sub IS_IMMUTABLE {
        local($inode) = @_;
	    eval q((($inode)-> &i_flags &  &S_IMMUTABLE));
    }' unless defined(&IS_IMMUTABLE);
    eval 'sub IS_NOATIME {
        local($inode) = @_;
	    eval q((($inode)-> &i_flags &  &MS_NOATIME));
    }' unless defined(&IS_NOATIME);
    eval 'sub IS_ZERO_WR {
        local($inode) = @_;
	    eval q((($inode)-> &i_flags &  &S_ZERO_WR));
    }' unless defined(&IS_ZERO_WR);
    eval 'sub UPDATE_ATIME {
        local($inode) = @_;
	    eval q( &if (! &IS_NOATIME($inode)  && ! &IS_RDONLY($inode)) {  ($inode->{i_atime}) =  &CURRENT_TIME;  ($inode->{i_dirt}) = 1; });
    }' unless defined(&UPDATE_ATIME);
    eval 'sub BLKROSET () { &_IO(0x12,93);}' unless defined(&BLKROSET);
    eval 'sub BLKROGET () { &_IO(0x12,94);}' unless defined(&BLKROGET);
    eval 'sub BLKRRPART () { &_IO(0x12,95);}' unless defined(&BLKRRPART);
    eval 'sub BLKGETSIZE () { &_IO(0x12,96);}' unless defined(&BLKGETSIZE);
    eval 'sub BLKFLSBUF () { &_IO(0x12,97);}' unless defined(&BLKFLSBUF);
    eval 'sub BLKRASET () { &_IO(0x12,98);}' unless defined(&BLKRASET);
    eval 'sub BLKRAGET () { &_IO(0x12,99);}' unless defined(&BLKRAGET);
    eval 'sub BMAP_IOCTL () {1;}' unless defined(&BMAP_IOCTL);
    eval 'sub FIBMAP () { &_IO(0x00,1);}' unless defined(&FIBMAP);
    eval 'sub FIGETBSZ () { &_IO(0x00,2);}' unless defined(&FIGETBSZ);
    if(defined(&__KERNEL__)) {
	require 'asm/semaphore.ph';
	require 'asm/bitops.ph';
	eval 'sub BH_Uptodate () {0;}' unless defined(&BH_Uptodate);
	eval 'sub BH_Dirty () {1;}' unless defined(&BH_Dirty);
	eval 'sub BH_Lock () {2;}' unless defined(&BH_Lock);
	eval 'sub BH_Req () {3;}' unless defined(&BH_Req);
	eval 'sub BH_Touched () {4;}' unless defined(&BH_Touched);
	eval 'sub BH_Has_aged () {5;}' unless defined(&BH_Has_aged);
	eval 'sub BH_Protected () {6;}' unless defined(&BH_Protected);
	eval 'sub BH_FreeOnIO () {7;}' unless defined(&BH_FreeOnIO);
	eval 'sub BH_MD () {8;}' unless defined(&BH_MD);
	require 'linux/pipe_fs_i.ph';
	require 'linux/minix_fs_i.ph';
	require 'linux/ext_fs_i.ph';
	require 'linux/ext2_fs_i.ph';
	require 'linux/hpfs_fs_i.ph';
	require 'linux/msdos_fs_i.ph';
	require 'linux/umsdos_fs_i.ph';
	require 'linux/iso_fs_i.ph';
	require 'linux/nfs_fs_i.ph';
	require 'linux/xia_fs_i.ph';
	require 'linux/sysv_fs_i.ph';
	require 'linux/affs_fs_i.ph';
	require 'linux/ufs_fs_i.ph';
	eval 'sub ATTR_MODE () {1;}' unless defined(&ATTR_MODE);
	eval 'sub ATTR_UID () {2;}' unless defined(&ATTR_UID);
	eval 'sub ATTR_GID () {4;}' unless defined(&ATTR_GID);
	eval 'sub ATTR_SIZE () {8;}' unless defined(&ATTR_SIZE);
	eval 'sub ATTR_ATIME () {16;}' unless defined(&ATTR_ATIME);
	eval 'sub ATTR_MTIME () {32;}' unless defined(&ATTR_MTIME);
	eval 'sub ATTR_CTIME () {64;}' unless defined(&ATTR_CTIME);
	eval 'sub ATTR_ATIME_SET () {128;}' unless defined(&ATTR_ATIME_SET);
	eval 'sub ATTR_MTIME_SET () {256;}' unless defined(&ATTR_MTIME_SET);
	eval 'sub ATTR_FORCE () {512;}' unless defined(&ATTR_FORCE);
	require 'linux/quota.ph';
	eval 'sub FL_POSIX () {1;}' unless defined(&FL_POSIX);
	eval 'sub FL_FLOCK () {2;}' unless defined(&FL_FLOCK);
	eval 'sub FL_BROKEN () {4;}' unless defined(&FL_BROKEN);
	eval 'sub FL_ACCESS () {8;}' unless defined(&FL_ACCESS);
	require 'linux/fcntl.ph';
	require 'linux/stat.ph';
	eval 'sub FLOCK_VERIFY_READ () {1;}' unless defined(&FLOCK_VERIFY_READ);
	eval 'sub FLOCK_VERIFY_WRITE () {2;}' unless defined(&FLOCK_VERIFY_WRITE);
	eval 'sub FASYNC_MAGIC () {0x4601;}' unless defined(&FASYNC_MAGIC);
	require 'linux/minix_fs_sb.ph';
	require 'linux/ext_fs_sb.ph';
	require 'linux/ext2_fs_sb.ph';
	require 'linux/hpfs_fs_sb.ph';
	require 'linux/msdos_fs_sb.ph';
	require 'linux/iso_fs_sb.ph';
	require 'linux/nfs_fs_sb.ph';
	require 'linux/xia_fs_sb.ph';
	require 'linux/sysv_fs_sb.ph';
	require 'linux/affs_fs_sb.ph';
	require 'linux/ufs_fs_sb.ph';
	eval 'sub BUF_CLEAN () {0;}' unless defined(&BUF_CLEAN);
	eval 'sub BUF_LOCKED () {1;}' unless defined(&BUF_LOCKED);
	eval 'sub BUF_LOCKED1 () {2;}' unless defined(&BUF_LOCKED1);
	eval 'sub BUF_DIRTY () {3;}' unless defined(&BUF_DIRTY);
	eval 'sub NR_LIST () {4;}' unless defined(&NR_LIST);
	if(defined(&CONFIG_BLK_DEV_INITRD)) {
	}
	require 'linux/minix_fs.ph';
	require 'linux/minix_fs_sb.ph';
    }
}
1;
