require '_h2ph_pre.ph';

unless(defined(&_MD_H)) {
    eval 'sub _MD_H () {1;}' unless defined(&_MD_H);
    require 'asm/segment.ph';
    require 'linux/major.ph';
    require 'linux/ioctl.ph';
    require 'linux/types.ph';
    eval 'sub MD_MAJOR_VERSION () {0;}' unless defined(&MD_MAJOR_VERSION);
    eval 'sub MD_MINOR_VERSION () {36;}' unless defined(&MD_MINOR_VERSION);
    eval 'sub MD_PATCHLEVEL_VERSION () {3;}' unless defined(&MD_PATCHLEVEL_VERSION);
    eval 'sub REGISTER_DEV () { &_IO ( &MD_MAJOR, 1);}' unless defined(&REGISTER_DEV);
    eval 'sub START_MD () { &_IO ( &MD_MAJOR, 2);}' unless defined(&START_MD);
    eval 'sub STOP_MD () { &_IO ( &MD_MAJOR, 3);}' unless defined(&STOP_MD);
    eval 'sub FAULT_SHIFT () {8;}' unless defined(&FAULT_SHIFT);
    eval 'sub PERSONALITY_SHIFT () {16;}' unless defined(&PERSONALITY_SHIFT);
    eval 'sub FACTOR_MASK () {0x000000ff;}' unless defined(&FACTOR_MASK);
    eval 'sub FAULT_MASK () {0x0000ff00;}' unless defined(&FAULT_MASK);
    eval 'sub PERSONALITY_MASK () {0x00ff0000;}' unless defined(&PERSONALITY_MASK);
    eval 'sub MD_RESERVED () {0;}' unless defined(&MD_RESERVED);
    eval 'sub LINEAR () {(1 <<  &PERSONALITY_SHIFT);}' unless defined(&LINEAR);
    eval 'sub STRIPED () {(2 <<  &PERSONALITY_SHIFT);}' unless defined(&STRIPED);
    eval 'sub RAID0 () { &STRIPED;}' unless defined(&RAID0);
    eval 'sub RAID1 () {(3 <<  &PERSONALITY_SHIFT);}' unless defined(&RAID1);
    eval 'sub RAID5 () {(4 <<  &PERSONALITY_SHIFT);}' unless defined(&RAID5);
    eval 'sub MAX_PERSONALITY () {5;}' unless defined(&MAX_PERSONALITY);
    eval 'sub MD_RESERVED_BYTES () {(64* 1024);}' unless defined(&MD_RESERVED_BYTES);
    eval 'sub MD_RESERVED_SECTORS () {( &MD_RESERVED_BYTES / 512);}' unless defined(&MD_RESERVED_SECTORS);
    eval 'sub MD_RESERVED_BLOCKS () {( &MD_RESERVED_BYTES /  &BLOCK_SIZE);}' unless defined(&MD_RESERVED_BLOCKS);
    eval 'sub MD_NEW_SIZE_SECTORS {
        local($x) = @_;
	    eval q((($x & ~( &MD_RESERVED_SECTORS - 1)) -  &MD_RESERVED_SECTORS));
    }' unless defined(&MD_NEW_SIZE_SECTORS);
    eval 'sub MD_NEW_SIZE_BLOCKS {
        local($x) = @_;
	    eval q((($x & ~( &MD_RESERVED_BLOCKS - 1)) -  &MD_RESERVED_BLOCKS));
    }' unless defined(&MD_NEW_SIZE_BLOCKS);
    eval 'sub MD_SB_BYTES () {4096;}' unless defined(&MD_SB_BYTES);
    eval 'sub MD_SB_WORDS () {( &MD_SB_BYTES / 4);}' unless defined(&MD_SB_WORDS);
    eval 'sub MD_SB_BLOCKS () {( &MD_SB_BYTES /  &BLOCK_SIZE);}' unless defined(&MD_SB_BLOCKS);
    eval 'sub MD_SB_SECTORS () {( &MD_SB_BYTES / 512);}' unless defined(&MD_SB_SECTORS);
    eval 'sub MD_SB_GENERIC_OFFSET () {0;}' unless defined(&MD_SB_GENERIC_OFFSET);
    eval 'sub MD_SB_PERSONALITY_OFFSET () {64;}' unless defined(&MD_SB_PERSONALITY_OFFSET);
    eval 'sub MD_SB_DISKS_OFFSET () {128;}' unless defined(&MD_SB_DISKS_OFFSET);
    eval 'sub MD_SB_DESCRIPTOR_OFFSET () {992;}' unless defined(&MD_SB_DESCRIPTOR_OFFSET);
    eval 'sub MD_SB_GENERIC_CONSTANT_WORDS () {32;}' unless defined(&MD_SB_GENERIC_CONSTANT_WORDS);
    eval 'sub MD_SB_GENERIC_STATE_WORDS () {32;}' unless defined(&MD_SB_GENERIC_STATE_WORDS);
    eval 'sub MD_SB_GENERIC_WORDS () {( &MD_SB_GENERIC_CONSTANT_WORDS +  &MD_SB_GENERIC_STATE_WORDS);}' unless defined(&MD_SB_GENERIC_WORDS);
    eval 'sub MD_SB_PERSONALITY_WORDS () {64;}' unless defined(&MD_SB_PERSONALITY_WORDS);
    eval 'sub MD_SB_DISKS_WORDS () {384;}' unless defined(&MD_SB_DISKS_WORDS);
    eval 'sub MD_SB_DESCRIPTOR_WORDS () {32;}' unless defined(&MD_SB_DESCRIPTOR_WORDS);
    eval 'sub MD_SB_RESERVED_WORDS () {(1024-  &MD_SB_GENERIC_WORDS -  &MD_SB_PERSONALITY_WORDS -  &MD_SB_DISKS_WORDS -  &MD_SB_DESCRIPTOR_WORDS);}' unless defined(&MD_SB_RESERVED_WORDS);
    eval 'sub MD_SB_EQUAL_WORDS () {( &MD_SB_GENERIC_WORDS +  &MD_SB_PERSONALITY_WORDS +  &MD_SB_DISKS_WORDS);}' unless defined(&MD_SB_EQUAL_WORDS);
    eval 'sub MD_SB_DISKS () {( &MD_SB_DISKS_WORDS /  &MD_SB_DESCRIPTOR_WORDS);}' unless defined(&MD_SB_DISKS);
    eval 'sub MD_FAULTY_DEVICE () {0;}' unless defined(&MD_FAULTY_DEVICE);
    eval 'sub MD_ACTIVE_DEVICE () {1;}' unless defined(&MD_ACTIVE_DEVICE);
    eval 'sub MD_SYNC_DEVICE () {2;}' unless defined(&MD_SYNC_DEVICE);
    eval 'sub MD_SB_MAGIC () {0xa92b4efc;}' unless defined(&MD_SB_MAGIC);
    eval 'sub MD_SB_CLEAN () {0;}' unless defined(&MD_SB_CLEAN);
    eval 'sub MD_SB_ERRORS () {1;}' unless defined(&MD_SB_ERRORS);
    if(defined(&__KERNEL__)) {
	require 'linux/mm.ph';
	require 'linux/fs.ph';
	require 'linux/blkdev.ph';
	eval 'sub MAX_REAL () {8;}' unless defined(&MAX_REAL);
	eval 'sub MAX_MD_DEV () {4;}' unless defined(&MAX_MD_DEV);
	eval 'sub MAX_MD_THREADS () {2;}' unless defined(&MAX_MD_THREADS);
	eval 'sub FACTOR {
	    local($a) = @_;
    	    eval q((($a)-> &repartition &  &FACTOR_MASK));
	}' unless defined(&FACTOR);
	eval 'sub MAX_FAULT {
	    local($a) = @_;
    	    eval q(((($a)-> &repartition &  &FAULT_MASK)>>8));
	}' unless defined(&MAX_FAULT);
	eval 'sub PERSONALITY {
	    local($a) = @_;
    	    eval q((($a)-> &repartition &  &PERSONALITY_MASK));
	}' unless defined(&PERSONALITY);
	eval 'sub FACTOR_SHIFT {
	    local($a) = @_;
    	    eval q(( &PAGE_SHIFT + ($a) - 10));
	}' unless defined(&FACTOR_SHIFT);
	eval 'sub THREAD_WAKEUP () {0;}' unless defined(&THREAD_WAKEUP);
    }
}
1;
