require '_h2ph_pre.ph';

unless(defined(&_LINUX_MM_H)) {
    eval 'sub _LINUX_MM_H () {1;}' unless defined(&_LINUX_MM_H);
    require 'linux/sched.ph';
    require 'linux/errno.ph';
    require 'linux/kernel.ph';
    if(defined(&__KERNEL__)) {
	require 'linux/string.ph';
	require 'asm/page.ph';
	require 'asm/atomic.ph';
	eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
	eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
	eval 'sub VM_READ () {0x0001;}' unless defined(&VM_READ);
	eval 'sub VM_WRITE () {0x0002;}' unless defined(&VM_WRITE);
	eval 'sub VM_EXEC () {0x0004;}' unless defined(&VM_EXEC);
	eval 'sub VM_SHARED () {0x0008;}' unless defined(&VM_SHARED);
	eval 'sub VM_MAYREAD () {0x0010;}' unless defined(&VM_MAYREAD);
	eval 'sub VM_MAYWRITE () {0x0020;}' unless defined(&VM_MAYWRITE);
	eval 'sub VM_MAYEXEC () {0x0040;}' unless defined(&VM_MAYEXEC);
	eval 'sub VM_MAYSHARE () {0x0080;}' unless defined(&VM_MAYSHARE);
	eval 'sub VM_GROWSDOWN () {0x0100;}' unless defined(&VM_GROWSDOWN);
	eval 'sub VM_GROWSUP () {0x0200;}' unless defined(&VM_GROWSUP);
	eval 'sub VM_SHM () {0x0400;}' unless defined(&VM_SHM);
	eval 'sub VM_DENYWRITE () {0x0800;}' unless defined(&VM_DENYWRITE);
	eval 'sub VM_EXECUTABLE () {0x1000;}' unless defined(&VM_EXECUTABLE);
	eval 'sub VM_LOCKED () {0x2000;}' unless defined(&VM_LOCKED);
	eval 'sub VM_STACK_FLAGS () {0x0177;}' unless defined(&VM_STACK_FLAGS);
	eval 'sub PG_locked () {0;}' unless defined(&PG_locked);
	eval 'sub PG_error () {1;}' unless defined(&PG_error);
	eval 'sub PG_referenced () {2;}' unless defined(&PG_referenced);
	eval 'sub PG_uptodate () {3;}' unless defined(&PG_uptodate);
	eval 'sub PG_free_after () {4;}' unless defined(&PG_free_after);
	eval 'sub PG_decr_after () {5;}' unless defined(&PG_decr_after);
	eval 'sub PG_swap_unlock_after () {6;}' unless defined(&PG_swap_unlock_after);
	eval 'sub PG_DMA () {7;}' unless defined(&PG_DMA);
	eval 'sub PG_reserved () {31;}' unless defined(&PG_reserved);
	eval 'sub PageLocked {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_locked, ($page)-> &flags)));
	}' unless defined(&PageLocked);
	eval 'sub PageError {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_error, ($page)-> &flags)));
	}' unless defined(&PageError);
	eval 'sub PageReferenced {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_referenced, ($page)-> &flags)));
	}' unless defined(&PageReferenced);
	eval 'sub PageDirty {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_dirty, ($page)-> &flags)));
	}' unless defined(&PageDirty);
	eval 'sub PageUptodate {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_uptodate, ($page)-> &flags)));
	}' unless defined(&PageUptodate);
	eval 'sub PageFreeAfter {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_free_after, ($page)-> &flags)));
	}' unless defined(&PageFreeAfter);
	eval 'sub PageDecrAfter {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_decr_after, ($page)-> &flags)));
	}' unless defined(&PageDecrAfter);
	eval 'sub PageSwapUnlockAfter {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_swap_unlock_after, ($page)-> &flags)));
	}' unless defined(&PageSwapUnlockAfter);
	eval 'sub PageDMA {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_DMA, ($page)-> &flags)));
	}' unless defined(&PageDMA);
	eval 'sub PageReserved {
	    local($page) = @_;
    	    eval q(( &test_bit( &PG_reserved, ($page)-> &flags)));
	}' unless defined(&PageReserved);
	eval 'sub __get_free_page {
	    local($priority) = @_;
    	    eval q( &__get_free_pages(($priority),0,0));
	}' unless defined(&__get_free_page);
	eval 'sub __get_dma_pages {
	    local($priority, $order) = @_;
    	    eval q( &__get_free_pages(($priority),($order),1));
	}' unless defined(&__get_dma_pages);
	eval 'sub free_page {
	    local($addr) = @_;
    	    eval q( &free_pages(($addr),0));
	}' unless defined(&free_page);
	eval 'sub GFP_BUFFER () {0x00;}' unless defined(&GFP_BUFFER);
	eval 'sub GFP_ATOMIC () {0x01;}' unless defined(&GFP_ATOMIC);
	eval 'sub GFP_USER () {0x02;}' unless defined(&GFP_USER);
	eval 'sub GFP_KERNEL () {0x03;}' unless defined(&GFP_KERNEL);
	eval 'sub GFP_NOBUFFER () {0x04;}' unless defined(&GFP_NOBUFFER);
	eval 'sub GFP_NFS () {0x05;}' unless defined(&GFP_NFS);
	eval 'sub GFP_IO () {0x06;}' unless defined(&GFP_IO);
	eval 'sub GFP_DMA () {0x80;}' unless defined(&GFP_DMA);
	eval 'sub GFP_LEVEL_MASK () {0xf;}' unless defined(&GFP_LEVEL_MASK);
	eval 'sub avl_empty () {  &NULL;}' unless defined(&avl_empty);
    }
}
1;
