require '_h2ph_pre.ph';

unless(defined(&_LINUX_NFS_FS_H)) {
    eval 'sub _LINUX_NFS_FS_H () {1;}' unless defined(&_LINUX_NFS_FS_H);
    require 'linux/nfs.ph';
    require 'linux/in.ph';
    require 'linux/nfs_mount.ph';
    eval 'sub NFS_READDIR_CACHE_SIZE () {64;}' unless defined(&NFS_READDIR_CACHE_SIZE);
    eval 'sub NFS_MAX_FILE_IO_BUFFER_SIZE () {16384;}' unless defined(&NFS_MAX_FILE_IO_BUFFER_SIZE);
    eval 'sub NFS_DEF_FILE_IO_BUFFER_SIZE () {1024;}' unless defined(&NFS_DEF_FILE_IO_BUFFER_SIZE);
    eval 'sub NFS_MAX_RPC_TIMEOUT () {(6* &HZ);}' unless defined(&NFS_MAX_RPC_TIMEOUT);
    eval 'sub NFS_LOOKUP_CACHE_SIZE () {64;}' unless defined(&NFS_LOOKUP_CACHE_SIZE);
    eval 'sub NFS_SUPER_MAGIC () {0x6969;}' unless defined(&NFS_SUPER_MAGIC);
    eval 'sub NFS_SERVER {
        local($inode) = @_;
	    eval q((($inode)-> ($i_sb->{u}->{nfs_sb}->{s_server})));
    }' unless defined(&NFS_SERVER);
    eval 'sub NFS_FH {
        local($inode) = @_;
	    eval q((($inode)-> ($u->{nfs_i}->{fhandle})));
    }' unless defined(&NFS_FH);
    eval 'sub NFS_RENAMED_DIR {
        local($inode) = @_;
	    eval q((($inode)-> ($u->{nfs_i}->{silly_rename_dir})));
    }' unless defined(&NFS_RENAMED_DIR);
    eval 'sub NFS_READTIME {
        local($inode) = @_;
	    eval q((($inode)-> ($u->{nfs_i}->{read_cache_jiffies})));
    }' unless defined(&NFS_READTIME);
    eval 'sub NFS_OLDMTIME {
        local($inode) = @_;
	    eval q((($inode)-> ($u->{nfs_i}->{read_cache_mtime})));
    }' unless defined(&NFS_OLDMTIME);
    eval 'sub NFS_ATTRTIMEO {
        local($inode) = @_;
	    eval q((($inode)-> ($u->{nfs_i}->{attrtimeo})));
    }' unless defined(&NFS_ATTRTIMEO);
    eval 'sub NFS_MINATTRTIMEO {
        local($inode) = @_;
	    eval q(( &S_ISREG(($inode)-> &i_mode)?  &NFS_SERVER($inode)-> &acregmin :  &NFS_SERVER($inode)-> &acdirmin));
    }' unless defined(&NFS_MINATTRTIMEO);
    eval 'sub NFS_CACHEINV {
        local($inode) = @_;
	    eval q( &do {  &NFS_READTIME($inode) =  &jiffies - 1000000;  &NFS_OLDMTIME($inode) = 0; }  &while (0));
    }' unless defined(&NFS_CACHEINV);
    if(defined(&__KERNEL__)) {
	eval 'sub NFS_ROOT () {"/tftpboot/%s";}' unless defined(&NFS_ROOT);
	eval 'sub NFS_ROOT_NAME_LEN () {256;}' unless defined(&NFS_ROOT_NAME_LEN);
	eval 'sub NFS_ROOT_ADDRS_LEN () {128;}' unless defined(&NFS_ROOT_ADDRS_LEN);
    }
}
1;
