require '_h2ph_pre.ph';

unless(defined(&_LINUX_SMB_FS_H)) {
    eval 'sub _LINUX_SMB_FS_H () {1;}' unless defined(&_LINUX_SMB_FS_H);
    require 'linux/smb.ph';
    require 'linux/fs.ph';
    require 'linux/in.ph';
    require 'linux/types.ph';
    require 'linux/smb_mount.ph';
    require 'linux/smb_fs_sb.ph';
    require 'linux/smb_fs_i.ph';
    eval 'sub SMB_IOC_GETMOUNTUID () { &_IOR(ord(\'u\'), 1,  &uid_t);}' unless defined(&SMB_IOC_GETMOUNTUID);
    if(defined(&__KERNEL__)) {
	eval 'sub SMB_READDIR_CACHE_SIZE () {64;}' unless defined(&SMB_READDIR_CACHE_SIZE);
	eval 'sub SMB_CACHE_TABLE_SIZE () {64;}' unless defined(&SMB_CACHE_TABLE_SIZE);
	eval 'sub SMB_SUPER_MAGIC () {0x517b;}' unless defined(&SMB_SUPER_MAGIC);
	eval 'sub SMB_SBP {
	    local($sb) = @_;
    	    eval q((( ($sb->{u}->{generic_sbp}))));
	}' unless defined(&SMB_SBP);
	eval 'sub SMB_INOP {
	    local($inode) = @_;
    	    eval q((( ($inode->{u}->{generic_ip}))));
	}' unless defined(&SMB_INOP);
	eval 'sub SMB_SERVER {
	    local($inode) = @_;
    	    eval q((( &SMB_SBP( ($inode->{i_sb}))-> &s_server)));
	}' unless defined(&SMB_SERVER);
	eval 'sub SMB_SERVATTR {
	    local($inode) = @_;
    	    eval q((( &SMB_SBP( ($inode->{i_sb}))-> &s_attr)));
	}' unless defined(&SMB_SERVATTR);
	eval 'sub SMB_FINFO {
	    local($inode) = @_;
    	    eval q((( &SMB_INOP($inode)-> &finfo)));
	}' unless defined(&SMB_FINFO);
	eval 'sub SMB_HEADER_LEN () {37;}' unless defined(&SMB_HEADER_LEN);
	if(defined(&DEBUG_SMB_MALLOC)) {
	    require 'linux/malloc.ph';
	} else {
	    eval 'sub smb_kmalloc {
	        local($s,$p) = @_;
    		eval q( &kmalloc($s,$p));
	    }' unless defined(&smb_kmalloc);
	    eval 'sub smb_kfree_s {
	        local($o,$s) = @_;
    		eval q( &kfree_s($o,$s));
	    }' unless defined(&smb_kfree_s);
	    eval 'sub smb_vmalloc {
	        local($s) = @_;
    		eval q( &vmalloc($s));
	    }' unless defined(&smb_vmalloc);
	    eval 'sub smb_vfree {
	        local($o) = @_;
    		eval q( &vfree($o));
	    }' unless defined(&smb_vfree);
	}
	if((defined(&DEBUG_SMB) ? &DEBUG_SMB : 0) > 0) {
	    eval 'sub DPRINTK () {( &format,  &args...)  &printk( &format ,   &args);}' unless defined(&DPRINTK);
	} else {
	    eval 'sub DPRINTK () {( &format,  &args...);}' unless defined(&DPRINTK);
	}
	if((defined(&DEBUG_SMB) ? &DEBUG_SMB : 0) > 1) {
	    eval 'sub DDPRINTK () {( &format,  &args...)  &printk( &format ,   &args);}' unless defined(&DDPRINTK);
	} else {
	    eval 'sub DDPRINTK () {( &format,  &args...);}' unless defined(&DDPRINTK);
	}
	if(0) {
	} else {
	}
    }
}
1;
